--
-- Change the ingame units between Metric, Imperial and US
--
-- Author Knuuud and Daveaich LS-UK.Info
-- Date: 09/06/2011
--

Units = {};

function Units:load()
	print("Unit switcher by Knuuud and Daveaich LS-UK.Info");
	self.Unitmode = 0;
end;

function Units:update(dt)
		if InputBinding.hasEvent(InputBinding.UnitMode) then
			self.Unitmode = self.Unitmode +1 ;
		end; 
		if self.Unitmode == 0 then
			self.unitmode0 = true;
			self.unitmode1 = false;
			self.unitmode2 = false;
			self.unitmode3 = false;			
		elseif self.Unitmode == 1 then
			self.unitmode0 = false;
			self.unitmode1 = true;
			self.unitmode2 = false;
			self.unitmode3 = false;	
			
		elseif self.Unitmode == 2 then
			self.unitmode0 = false;
			self.unitmode1 = false;
			self.unitmode2 = true;
			self.unitmode3 = false;	
			
		elseif self.Unitmode == 3 then
			self.unitmode0 = false;
			self.unitmode1 = false;
			self.unitmode2 = false;
			self.unitmode3 = true;	
			
		elseif self.Unitmode == 4 then
			self.Unitmode = 0;
	end;
end;	

--Steerable units--
function Units.draw(self, dt)

	local kmh = math.min(100, math.max(0, self.lastSpeed*self.speedDisplayScale*3600));
    local maxSpeed = 80;
    local currentFuelPercentage = 0;
    local fuelWarnPercentage = 20;
    local trailerFillLevel, trailerCapacity = self:getAttachedTrailersFillLevelAndCapacity();
  --local cam = self.cameras[self.camIndex];

	if self.unitmode0 then
		renderText(0.05, 0.0, 0.02, string.format(g_i18n:getText("Info_1"), self.typeDesc) .. " " ..  InputBinding.getKeyNamesOfDigitalAction(InputBinding.UnitMode));

      self.hudBackgroundOverlay:render();
  
      setTextBold(true);
  
      setTextColor(1.0, 1.0, 1.0, 1.0);
      setTextAlignment(RenderText.ALIGN_CENTER);
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer"), kmh));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer"), kmh));
  
      self.hudBarRedOverlay.width = self.hudBarWidth * math.min(1, kmh / maxSpeed);
      setOverlayUVs(self.hudBarRedOverlay.overlayId, 0, 0.05, 0, 1, math.min(1, kmh / maxSpeed), 0.05, math.min(1, kmh / maxSpeed), 1);
      self.hudBarRedOverlay:render();
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol"), g_currentMission.missionStats.money));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol"), g_currentMission.missionStats.money));
  
      if self.fuelCapacity > 0 then
          currentFuelPercentage = (self.fuelFillLevel / self.fuelCapacity + 0.0001) * 100;
      end;
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long"), self.fuelFillLevel));
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 0, 0, 1);
      else
          setTextColor(1, 1, 1, 1);
      end;
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long"), self.fuelFillLevel));
  
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 1, 1, 1);
      end;
  
      self.hudBarGreenOverlay.width = self.hudBarWidth * (self.fuelFillLevel / self.fuelCapacity); -- TODO: check for division by zero!
      setOverlayUVs(self.hudBarGreenOverlay.overlayId, 0, 0.05, 0, 1, self.fuelFillLevel / self.fuelCapacity, 0.05, self.fuelFillLevel / self.fuelCapacity, 1);
      self.hudBarGreenOverlay:render();
		
	
      if trailerFillLevel ~= nil and trailerCapacity ~= nil and trailerCapacity > 0 then
          self:drawGrainLevel(trailerFillLevel, trailerCapacity, 101);
      else
          -- if we don't have a trailer attached and we're not in a combine, render the frames overlay now
          if self.grainTankFillLevel == nil then
              self.hudFramesOverlay:render();
          end;
      end;
  
      setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(false);
  
      if self.showWaterWarning then
          --g_currentMission:addWarning("Fahren Sie nicht zu tief ins Wasser", 0.05, 0.025+0.007);
          g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_depth_into_the_water"), 0.05, 0.025+0.007);
      end;
  
      if table.getn(self.attachedImplements) > 1 then
          --g_currentMission:addHelpButtonText("Ger?teauswahl wechseln", InputBinding.SWITCH_IMPLEMENT);
          g_currentMission:addHelpButtonText(g_i18n:getText("Change_tools"), InputBinding.SWITCH_IMPLEMENT);
      end;
  
      --if cam ~= nil then
      --    renderText(0.4,0.5,0.03,string.format("rot: %f trans: %f", cam.rotX, Utils.vector3Length(cam.transX, cam.transY, cam.transZ)));
      --end;
  
      if Vehicle.debugRendering then
          renderText(0.5, 0.10, 0.025, string.format(" real acc: %1.2f", self.lastRealAcceleration));
          renderText(0.5, 0.13, 0.025, string.format("      acc: %1.2f", self.lastAcceleration));
          renderText(0.5, 0.16, 0.025, string.format("motor rpm: %1.2f", self.motor.lastMotorRpm));
          renderText(0.5, 0.19, 0.025, string.format("wheel rpm: %1.2f", self.wheelRpm));
      end;
	end;
	
	if self.unitmode1 then
		renderText(0.05, 0.0, 0.02, string.format(g_i18n:getText("Info_2"), self.typeDesc) .. " " ..  InputBinding.getKeyNamesOfDigitalAction(InputBinding.UnitMode));
		
      self.hudBackgroundOverlay:render();
  
      setTextBold(true);
  
      setTextColor(1.0, 1.0, 1.0, 1.0);
      setTextAlignment(RenderText.ALIGN_CENTER);
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer1"), (kmh / 1.6)));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer1"), (kmh / 1.6)));
  
      self.hudBarRedOverlay.width = self.hudBarWidth * math.min(1, kmh / maxSpeed);
      setOverlayUVs(self.hudBarRedOverlay.overlayId, 0, 0.05, 0, 1, math.min(1, kmh / maxSpeed), 0.05, math.min(1, kmh / maxSpeed), 1);
      self.hudBarRedOverlay:render();
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol1"), g_currentMission.missionStats.money));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol1"), g_currentMission.missionStats.money));
  
      if self.fuelCapacity > 0 then
          currentFuelPercentage = (self.fuelFillLevel / self.fuelCapacity + 0.0001) * 100;
      end;
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long1"), (self.fuelFillLevel / 4.55)));
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 0, 0, 1);
      else
          setTextColor(1, 1, 1, 1);
      end;
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long1"), (self.fuelFillLevel / 4.55)));
  
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 1, 1, 1);
      end;
  
      self.hudBarGreenOverlay.width = self.hudBarWidth * (self.fuelFillLevel / self.fuelCapacity); -- TODO: check for division by zero!
      setOverlayUVs(self.hudBarGreenOverlay.overlayId, 0, 0.05, 0, 1, self.fuelFillLevel / self.fuelCapacity, 0.05, self.fuelFillLevel / self.fuelCapacity, 1);
      self.hudBarGreenOverlay:render();
		
	
      if trailerFillLevel ~= nil and trailerCapacity ~= nil and trailerCapacity > 0 then
          self:drawGrainLevel(trailerFillLevel, trailerCapacity, 101);
      else
          -- if we don't have a trailer attached and we're not in a combine, render the frames overlay now
          if self.grainTankFillLevel == nil then
              self.hudFramesOverlay:render();
          end;
      end;
  
      setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(false);
  
      if self.showWaterWarning then
          --g_currentMission:addWarning("Fahren Sie nicht zu tief ins Wasser", 0.05, 0.025+0.007);
          g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_depth_into_the_water"), 0.05, 0.025+0.007);
      end;
  
      if table.getn(self.attachedImplements) > 1 then
          --g_currentMission:addHelpButtonText("Ger?teauswahl wechseln", InputBinding.SWITCH_IMPLEMENT);
          g_currentMission:addHelpButtonText(g_i18n:getText("Change_tools"), InputBinding.SWITCH_IMPLEMENT);
      end;
  
      --if cam ~= nil then
      --    renderText(0.4,0.5,0.03,string.format("rot: %f trans: %f", cam.rotX, Utils.vector3Length(cam.transX, cam.transY, cam.transZ)));
      --end;
  
      if Vehicle.debugRendering then
          renderText(0.5, 0.10, 0.025, string.format(" real acc: %1.2f", self.lastRealAcceleration));
          renderText(0.5, 0.13, 0.025, string.format("      acc: %1.2f", self.lastAcceleration));
          renderText(0.5, 0.16, 0.025, string.format("motor rpm: %1.2f", self.motor.lastMotorRpm));
          renderText(0.5, 0.19, 0.025, string.format("wheel rpm: %1.2f", self.wheelRpm));
      end;	
	end;
	
	if self.unitmode2 then
	renderText(0.05, 0.0, 0.02, string.format(g_i18n:getText("Info_3"), self.typeDesc) .. " " ..  InputBinding.getKeyNamesOfDigitalAction(InputBinding.UnitMode));

      self.hudBackgroundOverlay:render();
  
      setTextBold(true);
  
      setTextColor(1.0, 1.0, 1.0, 1.0);
      setTextAlignment(RenderText.ALIGN_CENTER);
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer1"), (kmh / 1.6)));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer1"), (kmh / 1.6)));
  
      self.hudBarRedOverlay.width = self.hudBarWidth * math.min(1, kmh / maxSpeed);
      setOverlayUVs(self.hudBarRedOverlay.overlayId, 0, 0.05, 0, 1, math.min(1, kmh / maxSpeed), 0.05, math.min(1, kmh / maxSpeed), 1);
      self.hudBarRedOverlay:render();
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol2"), g_currentMission.missionStats.money));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol2"), g_currentMission.missionStats.money));
  
      if self.fuelCapacity > 0 then
          currentFuelPercentage = (self.fuelFillLevel / self.fuelCapacity + 0.0001) * 100;
      end;
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long1"), (self.fuelFillLevel / 3.79)));
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 0, 0, 1);
      else
          setTextColor(1, 1, 1, 1);
      end;
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long1"), (self.fuelFillLevel / 3.79)));
  
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 1, 1, 1);
      end;
  
      self.hudBarGreenOverlay.width = self.hudBarWidth * (self.fuelFillLevel / self.fuelCapacity); -- TODO: check for division by zero!
      setOverlayUVs(self.hudBarGreenOverlay.overlayId, 0, 0.05, 0, 1, self.fuelFillLevel / self.fuelCapacity, 0.05, self.fuelFillLevel / self.fuelCapacity, 1);
      self.hudBarGreenOverlay:render();
		
	
      if trailerFillLevel ~= nil and trailerCapacity ~= nil and trailerCapacity > 0 then
          self:drawGrainLevel(trailerFillLevel, trailerCapacity, 101);
      else
          -- if we don't have a trailer attached and we're not in a combine, render the frames overlay now
          if self.grainTankFillLevel == nil then
              self.hudFramesOverlay:render();
          end;
      end;
  
      setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(false);
  
      if self.showWaterWarning then
          --g_currentMission:addWarning("Fahren Sie nicht zu tief ins Wasser", 0.05, 0.025+0.007);
          g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_depth_into_the_water"), 0.05, 0.025+0.007);
      end;
  
      if table.getn(self.attachedImplements) > 1 then
          --g_currentMission:addHelpButtonText("Ger?teauswahl wechseln", InputBinding.SWITCH_IMPLEMENT);
          g_currentMission:addHelpButtonText(g_i18n:getText("Change_tools"), InputBinding.SWITCH_IMPLEMENT);
      end;
  
      --if cam ~= nil then
      --    renderText(0.4,0.5,0.03,string.format("rot: %f trans: %f", cam.rotX, Utils.vector3Length(cam.transX, cam.transY, cam.transZ)));
      --end;
  
      if Vehicle.debugRendering then
          renderText(0.5, 0.10, 0.025, string.format(" real acc: %1.2f", self.lastRealAcceleration));
          renderText(0.5, 0.13, 0.025, string.format("      acc: %1.2f", self.lastAcceleration));
          renderText(0.5, 0.16, 0.025, string.format("motor rpm: %1.2f", self.motor.lastMotorRpm));
          renderText(0.5, 0.19, 0.025, string.format("wheel rpm: %1.2f", self.wheelRpm));
      end;
	end;  
	  
	if self.unitmode3 then
	renderText(0.05, 0.0, 0.02, string.format(g_i18n:getText("Info_0"), self.typeDesc) .. " " ..  InputBinding.getKeyNamesOfDigitalAction(InputBinding.UnitMode));
	end;
	  
end;

function Units:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local UnitsMode = Utils.getVectorFromString(getXMLString(xmlFile, key.."#UnitsMode"));
	if UnitsMode ~= nil then
		self.Unitmode = UnitsMode;
	else
		self.Unitmode = 0;
	end;
end;
function Units:getSaveAttributesAndNodes(nodeIdent)
    local attributes, nodes;
	
    local modStr = ""	
	if self.Unitmode ~= nil then
		modStr = 'UnitsMode="'..self.Unitmode..'" ';
	end
	
    if attributes == nil then
        attributes = modStr;
    else
        attributes = attributes .. " "..modStr;
    end;
    return attributes, nodes;
end;

--Combine frames--
function Units.drawcomb(self, dt)
    
	if self.unitmode0 or self.unitmode1 or self.unitmode2 then  
	
		if self.isClient then
          local percent = 0;
          if self.grainTankCapacity > 0 then
              percent = self.grainTankFillLevel/self.grainTankCapacity*100;
              if self.currentPipeState == 2 and not self.pipeParticleActivated and self.grainTankFillLevel > 0 then
                  g_currentMission:addExtraPrintText(g_i18n:getText("Move_the_pipe_over_a_trailer"));
              elseif self.grainTankFillLevel == self.grainTankCapacity then
                  g_currentMission:addExtraPrintText(g_i18n:getText("Dump_corn_to_continue_threshing"));
              end;
          end;
          if self.drawFillLevel then
              self:drawGrainLevel(self.grainTankFillLevel, self.grainTankCapacity, 95);
          else
              self:drawGrainLevel(0,0, 101);
          end;
          if self.numAttachedCutters > 0 then
              if self.isThreshing then
                  g_currentMission:addHelpButtonText(g_i18n:getText("Turn_off_cutter"), InputBinding.ACTIVATE_THRESHING);
              else
                  g_currentMission:addHelpButtonText(g_i18n:getText("Turn_on_cutter"), InputBinding.ACTIVATE_THRESHING);
              end;
          end;
          if self.numPipeStates == 2 then
              if self.targetPipeState == 2 then
                  g_currentMission:addHelpButtonText(g_i18n:getText("Pipe_in"), InputBinding.EMPTY_GRAIN);
              else
                  if percent > 80 then
                      g_currentMission:addHelpButtonText(g_i18n:getText("Dump_corn"), InputBinding.EMPTY_GRAIN);
                  end;
              end;
          end;
  
          if self.currentGrainTankFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN then
              g_currentMission:setFruitOverlayFruitType(self.currentGrainTankFruitType);
          end;
  
          local printRainWarning = false;
          local printSpeedLevelWarning = false;
          local speedLevelStr;
          local speedLevelKeyStr;
          local speedLevel = 10;
          for _, implement in pairs(self.attachedCutters) do
              local cutter = implement.object;
              printRainWarning = printRainWarning or cutter.printRainWarning;
  
              if math.abs(cutter.speedViolationTimer - cutter.speedViolationMaxTime) > 2 then
                  printSpeedLevelWarning = true;
                  if Cutter.getUseLowSpeedLimit(cutter) then
                      if speedLevel > 1 then
                          speedLevel = 1;
                          speedLevelStr = "1";
                          speedLevelKeyStr = InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL1)
                      end;
                  else
                      if speedLevel > 2 then
                          speedLevel = 2;
                          speedLevelStr = "2";
                          speedLevelKeyStr = InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL2)
                      end;
                  end;
              end;
          end;
  
          if printRainWarning then
              g_currentMission:addWarning(g_i18n:getText("Dont_do_threshing_during_rain_or_hail"), 0.018, 0.033);
          end;
          if printSpeedLevelWarning then
              g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast") .. "\n" .. string.format(g_i18n:getText("Cruise_control_levelN"), speedLevelStr, speedLevelKeyStr), 0.07+0.022, 0.019+0.029);
          end;
      end;
	end;
	if self.unitmode3 then
	end;
end;

--Modifiers--
Steerable.loadFromAttributesAndNodes = Utils.appendedFunction(Steerable.loadFromAttributesAndNodes, Units.loadFromAttributesAndNodes);
Steerable.getSaveAttributesAndNodes = Utils.appendedFunction(Steerable.getSaveAttributesAndNodes, Units.getSaveAttributesAndNodes);
Steerable.load = Utils.appendedFunction(Steerable.load, Units.load);
Steerable.update = Utils.appendedFunction(Steerable.update, Units.update);
Steerable.draw = Units.draw;
Combine.draw = Units.drawcomb;